require "defines"

--flying text colors
RED = {r = 0.7}
GREEN = {g = 0.7}
YELLOW = {r = 0.7, g = 0.7}



--
--Events
--

game.oninit(function()
	if glob.active == nil then
		glob.active = true
		glob.ammostacksize = 25
	end
end)

game.onload(function()
	if glob.active == nil then
		glob.active = true
		glob.ammostacksize = 25
	end
end)

function onbuiltentity(event)
	if glob.active then
		if event.createdentity.name == "car" then
			autoLoadCar(event.createdentity)
		elseif event.createdentity.name == "gun-turret" then
			autoLoadTurret(event.createdentity)
		end
	end
end

game.onevent(defines.events.onbuiltentity, function(event) onbuiltentity(event) end)



--
--Functions
--

function autoLoadCar(car)
	local main = game.player.getinventory(defines.inventory.playermain)
	local coalcount = main.getitemcount("coal")
	local coalstack = game.itemprototypes["coal"].stacksize
	if coalcount > 0 then
		if coalcount > coalstack then
			main.remove({name="coal", count=coalstack})
			car.insert({name="coal", count=coalstack})
			text("+"..coalstack.." "..game.getlocaliseditemname("coal"), car.position, GREEN)
		else
			main.remove({name="coal", count=coalcount})
			car.insert({name="coal", count=coalcount})
			text("+"..coalcount.." "..game.getlocaliseditemname("coal"), car.position, YELLOW)
		end
	else
		text("No fuel.", car.position, RED)
	end
end

function autoLoadTurret(turret)
	local main = game.player.getinventory(defines.inventory.playermain)
	local pbm = main.getitemcount("piercing-bullet-magazine")
	local bbm = main.getitemcount("basic-bullet-magazine")
	if pbm > 0 then
		if pbm > glob.ammostacksize then
			main.remove({name="piercing-bullet-magazine", count=glob.ammostacksize})
			turret.insert({name="piercing-bullet-magazine", count=glob.ammostacksize})
			text("+"..glob.ammostacksize.." "..game.getlocaliseditemname("piercing-bullet-magazine"), turret.position, GREEN)
		else
			main.remove({name="piercing-bullet-magazine", count=pbm})
			turret.insert({name="piercing-bullet-magazine", count=pbm})
			text("+"..pbm.." "..game.getlocaliseditemname("piercing-bullet-magazine"), turret.position, YELLOW)
		end
	elseif bbm > 0 then
		if bbm > glob.ammostacksize then
			main.remove({name="basic-bullet-magazine", count=glob.ammostacksize})
			turret.insert({name="basic-bullet-magazine", count=glob.ammostacksize})
			text("+"..glob.ammostacksize.." "..game.getlocaliseditemname("basic-bullet-magazine"), turret.position, GREEN)
		else
			main.remove({name="basic-bullet-magazine", count=bbm})
			turret.insert({name="basic-bullet-magazine", count=bbm})
			text("+"..bbm.." "..game.getlocaliseditemname("basic-bullet-magazine"), turret.position, YELLOW)
		end
	else
		text("No ammo.", turret.position, RED)
	end
end

function text(line, pos, colour) --colour as optional
  if colour == nil then
    game.createentity({name="flying-text", position=pos, text=line})
  else
    game.createentity({name="flying-text", position=pos, text=line, color=colour})
  end
end

--
-- Mod interface
--

remote.addinterface("autofill",
{
  setammostacksize = function(amount)
		if amount > 0 and amount <= 100 then
			glob.ammostacksize = amount
		end
  end,
	setactive = function(turnOn)
		if turnOn then
			glob.active = true
		else
			glob.active = false
		end
  end,
})
